"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const mongodb_1 = require("mongodb");
const model_1 = __importDefault(require("./model"));
class SafeMongo {
    constructor(uri, database_name, options) {
        this.database_name = database_name;
        this.waiting = [];
        options = Object.assign({ useNewUrlParser: true }, options);
        this.client = new mongodb_1.MongoClient(uri, options);
    }
    addModel(definition) {
        return new model_1.default(this, definition);
    }
    async awaitConnected() {
        if (this.db)
            return;
        return new Promise((yes) => this.waiting.push(() => yes()));
    }
    connect() {
        return this.client.connect().then(() => this.db = this.client.db(this.database_name)).then(() => {
            this.waiting.forEach(e => e());
        });
    }
    disconnect() {
        return this.client.close();
    }
}
exports.default = SafeMongo;
//# sourceMappingURL=index.js.map